﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace HutongGames.PlayMaker.Actions
{


	public class InkChooseChoice : FsmStateAction 
	{
		[RequiredField]
		[UIHint(UIHint.Variable)]
		[CheckForComponent(typeof(PlaymakerInkProxy))]
		[Tooltip("We need a PlaymakerInkProxy script.")]
		public PlaymakerInkProxy proxy;

		[RequiredField]
		[UIHint(UIHint.Variable)]
		[Tooltip("Index of the choice to pick.")]
		public FsmInt index;

		[Tooltip("Event to send on completion.")]
		public FsmEvent finishedEvent;

		[Tooltip("Event to send on error.")]
		public FsmEvent errorEvent;

		public override void Reset()
		{
			proxy = null;
			index = null;
			finishedEvent = null;
			errorEvent = null;

		}

		public override void OnEnter()
		{
			if (proxy.chooseChoiceIndex (index.Value))
			{
				if (finishedEvent != null)
					Fsm.Event (finishedEvent);
				else
					Finish ();
			} else if (errorEvent != null)
			{
				Fsm.Event (errorEvent);
			}

			Finish ();
		}

	}
}
