﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace HutongGames.PlayMaker.Actions
{

	public class InkGetCurrentTags : FsmStateAction 
	{

		[RequiredField]
		[UIHint(UIHint.Variable)]
		[CheckForComponent(typeof(PlaymakerInkProxy))]
		[Tooltip("We need a PlaymakerInkProxy script.")]
		public PlaymakerInkProxy proxy;

		[RequiredField]
		[UIHint(UIHint.Variable)]
		[Tooltip("String Array to hold tags")]
		[ArrayEditor(VariableType.String)]
		public FsmArray returnArray;

		public bool everyFrame; 

		public override void Reset ()
		{
			proxy = null;
			returnArray = null;
			everyFrame = false;
		}

		public override void OnEnter()
		{
			string[] strings;
			strings = proxy.getCurrentTags ();
			returnArray.Values = strings;
			if (!everyFrame)
				Finish ();
		}
	}
}