﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace HutongGames.PlayMaker.Actions
{

	public class InkGetVariable : FsmStateAction 
	{
		[RequiredField]
		[UIHint(UIHint.Variable)]
		[CheckForComponent(typeof(PlaymakerInkProxy))]
		[Tooltip("We need a PlaymakerInkProxy script.")]
		public PlaymakerInkProxy proxy;

		[RequiredField]
		[UIHint(UIHint.FsmString)]
		[Tooltip("Name of the variable to find.")]
		public FsmString nameString;

		[Note("You only need to set one of these, but will check and set each if you pass a variable. Ink does not have built in type checking so string is safest.")]

		[UIHint(UIHint.FsmString)]
		[Tooltip("Return value to string?")]
		public FsmString returnString;

		[UIHint(UIHint.FsmInt)]
		[Tooltip("Return value to int?")]
		public FsmInt returnInt;

		[UIHint(UIHint.FsmBool)]
		[Tooltip("Return value to bool?")]
		public FsmBool returnBool;

		[UIHint(UIHint.FsmFloat)]
		[Tooltip("Return value to float?")]
		public FsmFloat returnFloat;

		public override void Reset ()
		{
			proxy = null;
			nameString = null;
			returnString = null;
			returnBool = null;
			returnFloat = null;
			returnInt = null;
		}

		public override void OnEnter()
		{
			if (!returnString.IsNone)
			{	
				returnString.Value = proxy.getVariableString (nameString.Value);
			}

			if (!returnInt.IsNone)
			{	
				Debug.Log ("here!!!");
				returnInt.Value = proxy.getVariableInt (nameString.Value);
			}

			if (!returnFloat.IsNone)
			{	
				returnFloat.Value = proxy.getVariableFloat (nameString.Value);
			}

			if (!returnBool.IsNone)
			{	
				returnBool.Value = proxy.getVariableBool (nameString.Value);
			} 

			Finish ();
		}
	}
}
