﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace HutongGames.PlayMaker.Actions
{


	public class InkGoToStoryPath : FsmStateAction 
	{
		
		[RequiredField]
		[UIHint(UIHint.Variable)]
		[CheckForComponent(typeof(PlaymakerInkProxy))]
		[Tooltip("We need a PlaymakerInkProxy script.")]
		public PlaymakerInkProxy proxy;

		[RequiredField]
		[UIHint(UIHint.FsmString)]
		[Tooltip("Index of the choice to pick.")]
		public FsmString pathString;

		[Tooltip("Event to send on completion.")]
		public FsmEvent finishedEvent;
	

		public override void Reset()
		{
			proxy = null;
			pathString = null;
			finishedEvent = null;

		}

		public override void OnEnter()
		{
			proxy.choosePathString (pathString.Value);

			if (finishedEvent != null)
			{
				Fsm.Event (finishedEvent);
				Finish ();
			}

			Finish ();
		}

	}
}

