﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace HutongGames.PlayMaker.Actions
{

	public class InkSetVariable : FsmStateAction 
	{
		[RequiredField]
		[UIHint(UIHint.Variable)]
		[CheckForComponent(typeof(PlaymakerInkProxy))]
		[Tooltip("We need a PlaymakerInkProxy script.")]
		public PlaymakerInkProxy proxy;

		[RequiredField]
		[UIHint(UIHint.FsmString)]
		[Tooltip("Name of the variable to set.")]
		public FsmString nameString;

		[Note("You only need to set one of these, and we will evaluate in order and set the first one.")]

		[UIHint(UIHint.FsmString)]
		[Tooltip("Set value to string?")]
		public FsmString setString;

		[UIHint(UIHint.FsmInt)]
		[Tooltip("Set value to int?")]
		public FsmInt setInt;

		[UIHint(UIHint.FsmBool)]
		[Tooltip("Set value to bool?")]
		public FsmBool setBool;

		[UIHint(UIHint.FsmFloat)]
		[Tooltip("Set value to float?")]
		public FsmFloat setFloat;

		public override void Reset ()
		{
			proxy = null;
			nameString = null;
			setString = null;
			setBool = null;
			setFloat = null;
			setInt = null;
		}

		public override void OnEnter()
		{
			if (!setString.IsNone)
			{	
				proxy.setVariableState (nameString.Value, setString.Value);
				Finish ();
			}

			if (!setInt.IsNone)
			{	
				proxy.setVariableState (nameString.Value, setInt.Value);
				Finish ();			
			}

			if (!setBool.IsNone)
			{	
				proxy.setVariableState (nameString.Value, setBool.Value);
				Finish ();
			} 

			if (!setFloat.IsNone)
			{	
				proxy.setVariableState (nameString.Value, setFloat.Value);
				Finish ();
			}
				

			Finish ();
		}
	}
}
