﻿using Ink.Runtime;
using UnityEngine;

namespace HutongGames.PlayMaker.Actions
{
	
	public class InkStoryContinue : FsmStateAction 
	{
		[RequiredField]
		[UIHint(UIHint.Variable)]
		[CheckForComponent(typeof(PlaymakerInkProxy))]
		[Tooltip("We need a PlaymakerInkProxy script.")]
		public PlaymakerInkProxy proxy;

		[RequiredField]
		[UIHint(UIHint.Variable)]
		[Tooltip("String to return story into (sends 1 line at a time).")]
		public FsmString returnString;

		[Tooltip("Event to send with each line.")]
		public FsmEvent loopEvent;

		[Tooltip("Event to send when finished.")]
		public FsmEvent finishedEvent;

		public override void Reset()
		{
			proxy = null;
			returnString = null;
			loopEvent = null;
			finishedEvent = null;
		}

		public override void OnEnter()
		{
			DoContinue ();
			Finish ();
		}

		void DoContinue()
		{
			if (proxy.canContinue ()) 
			{
				returnString.Value = proxy.Continue ();
				if (loopEvent != null) 
				{
					Fsm.Event (loopEvent);
				}
				return;
			} 
			else if (finishedEvent != null) 
			{
				Fsm.Event (finishedEvent);
			}
		}


	}
}
