﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Ink.Runtime;
using HutongGames.PlayMaker;

public class PlaymakerInkProxy : MonoBehaviour {

	//A proxy for common Ink story interaction
	//Exposes Ink commands so they can be easily reached through playmaker
	//Do whatever you want with it, it's free for any use
	//Original Code by Rim Vilgalys (vilgalys@gmail.com)
	//Ink: http://www.inklestudios.com/ink/
	//Playmaker: http://www.hutonggames.com/

	[SerializeField]
	private TextAsset inkJSONAsset;
	public Story story;

	// Use this for initialization
	void Awake () 
	{
		DontDestroyOnLoad (gameObject);
		StartStory ();
	}

	void StartStory () 
	{
		story = new Story (inkJSONAsset.text);
	}
		
	public bool canContinue()
	{
		return story.canContinue;
	}

	public string Continue()
	{
		return story.Continue ().Trim ();
	}

	public int currentChoiceCount()
	{
		return story.currentChoices.Count;
	}

	public string getChoiceString(int i)
	{
		return story.currentChoices [i].text.Trim();
	}

	public bool chooseChoiceIndex(int i)
	{
		if (story.currentChoices [i] == null)
			return false;
		else
			story.ChooseChoiceIndex (i);
		return true;
	}

	public void choosePathString(string path)
	{
		story.ChoosePathString (path);
	}

	public string[] getCurrentTags()
	{
		List <string> tags;
		tags = story.currentTags;

		string[] array = tags.ToArray ();
		return array;
	}

	public string[] getGlobalTags()
	{
		List <string> tags;
		tags = story.globalTags;

		string[] array = tags.ToArray ();
		return array;
	}

	public string getVariableString(string name)
	{
		Debug.Log ("why are we here.");
		string s = (string) story.variablesState [name];
		return s;
	}

	public bool getVariableBool(string name)
	{
		bool b = (bool)story.variablesState [name];
		return b;
	}

	public int getVariableInt(string name)
	{
		Debug.Log ("we should be here.");
		int i = (int)story.variablesState [name];
		return i;
	}

	public float getVariableFloat(string name)
	{
		float f = (float)story.variablesState [name];
		return f;
	}

	public void setVariableState(string name, string value)
	{
		story.variablesState [name] = value;
	}

	public void setVariableState(string name, int value)
	{
		story.variablesState [name] = value;
	}

	public void setVariableState(string name, float value)
	{
		story.variablesState [name] = value;
	}

	public void setVariableState(string name, bool value)
	{
		story.variablesState [name] = value;
	}


}
